<?php

namespace App\Controller;

use App\Entity\Tasarim;
use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityManagerInterface;
use Matrix\Exception;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\BaseController;
use App\Entity\Modul;
use ZipArchive;

class PanelTasarimController extends BaseController
{
    /**
     * @Route("/admin/tasarim", name="tasarim_homepage")
     */
    public function index(): Response
    {
        return $this->render('panel/tasarim/index.html.twig');
    }



    /**
     * @Route("/admin/tasarim/getir", name="tasarim_getir")
     */
    public function getir(): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $tasarimlar=$qb->select('t.adi,t.id,t.translate,t.grup,m.adi as mAdi,m.id as mId,t.gorunum')
            ->from('App:Tasarim', 't')
            ->leftjoin('t.modul','m')
            ->orderBy('t.grup')
            ->getQuery()
            ->getScalarResult();



        return $this->render('panel/tasarim/getir.html.twig',array('tasarimlar'=>$tasarimlar));
    }

    /**
     * @Route("/admin/tasarim/tema_getir", name="tasarim_tema_getir")
     */
    public function tema_getir(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $yol = $request->request->get('yol');

        $dizin = ("dist/".$yol);
        $dizin_ac = opendir($dizin);
        $dosyalar = [];
        while($okundu = readdir($dizin_ac)){
            if ($okundu=='..'){
                $dosyalar[] = ['adi'=>$okundu,'klasor'=>2];
            }
            if(!strstr($okundu,'.')){
                $dosyalar[] = ['adi'=>$okundu,'klasor'=>1];
            }else{
                if (!is_dir($okundu)){
                    $dosyalar[] = ['adi'=>$okundu,'klasor'=>0];
                }
            }
        }
        closedir($dizin_ac);



        return $this->render('panel/tasarim/tema_getir.html.twig',array('dosyalar'=>$dosyalar,'yol'=>$yol));
    }

    /**
     * @Route("/admin/tasarim/tema_dosyaAc", name="tasarim_tema_dosyaAc")
     */
    public function tema_dosyaAc(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $yol = $request->request->get('yol');

        $dosya= fopen('dist/'.$yol, "r");
        $dosyaVerisi = fread($dosya,filesize('dist/'.$yol));
        fclose($dosya);




        return $this->render('panel/tasarim/tema_dosyaAc.html.twig',array('dosyaVerisi'=>$dosyaVerisi));
    }


    /**
     * @Route("/admin/tasarim/tema_dosyKaydetc", name="tasarim_tema_dosyaKaydet")
     */
    public function tema_dosyaKaydet(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $yol = $request->request->get('yol');
        $dosyaVerisi = $request->request->get('dosyaVerisi');
        $bul = $request->request->get('bul');
        $degistir = $request->request->get('degistir');

        if ($bul!=""){
            $dosyaVerisi = str_replace($bul,$degistir,$dosyaVerisi);
        }

        $dosya= fopen('dist/'.$yol, "w");
        fwrite($dosya,$dosyaVerisi);
        fclose($dosya);


       return new Response('');
    }


    /**
     * @Route("/admin/tasarim/duzenle/{id}", name="tasarim_duzenle")
     */
    public function duzenle($id): Response
    {
        $em = $this->getDoctrine()->getManager();
        $id = explode('_',$id);


        $qb = $em->createQueryBuilder();
        $tasarim=$qb->select('t.id,t.translate')
            ->from('App:Tasarim', 't')
            ->where('t.id='.$id[0].' and t.gorunum='.$id[2])
            ->getQuery()
            ->getScalarResult();



        return $this->render('panel/tasarim/duzenle.html.twig',array('tasarim'=>$tasarim,'gorunum'=>$id[2]));

    }



    /**
     * @Route("/admin/tasarim/hazirla", name="tasarim_hazirla")
     */
    public function hazirla(Request $request, EntityManagerInterface $em): Response{


        $bilgiler = $this->bilgiler();

        ini_set('max_execution_time', 0);
        set_time_limit(0);


        $dd = $request->request->get('dd');
        $gorunum = $request->request->get('gorunum');
        $tasarim = $request->request->get('tasarim');
        $modul = $request->request->get('modul');

        $qb = $em->createQueryBuilder();
        $tasarimlar=$qb->select('t.adi,t.id,t.translate,t.grup,m.adi as mAdi,t.gorunum,m.tabloAdi')
            ->from('App:Tasarim', 't')
            ->where('t.id = '.$tasarim)
            ->leftjoin('t.modul','m')
            ->orderBy('t.grup')
            ->getQuery()
            ->getScalarResult();


        $translate = $request->request->get('translate');


        if ($dd==1) {
            if ($tasarimlar[0]['adi'] == 'Css') {
                $veriBol = explode('<link ', $translate);
                $yeniVeriler = "";
                foreach ($veriBol as $key => $vv) {

                    if ($key != 0) {
                        if (strstr($vv, 'http')) {
                            $xx = $vv;
                        } else {
                            $xx = str_replace('href="', 'href="/dist/', $vv);
                        }

                        $yeniVeriler .= "<link " . $xx . "<noscript><link " . $xx . "</noscript>";
                    }
                }
                $translate = $yeniVeriler;
            } elseif ($tasarimlar[0]['adi'] == 'Js') {
                $veriBol = explode('<script ', $translate);
                $yeniVeriler = "";
                foreach ($veriBol as $key => $vv) {
                    $xx = $vv;
                    if ($key != 0) {
                        if (!strstr($vv, 'http')) {
                            $xx = str_replace('src="', 'src="/dist/', $xx);
                        }


                        if (!strstr($xx, 'defer')) {
                            if (!strstr($xx, 'anakutuphane')) {
                                $xx = "defer " . $xx;
                            }
                        }
                        $yeniVeriler .= "<script " . $xx;

                    }
                }
                $translate = $yeniVeriler;
            } else {
                $promp = 'Sana bir html kod ve yapılması gerekeni söyliceğim. Kullanacağımız dil twig dilidir. Gerekli html kodlarını aşağıda veriyorum. Aynı şekilde komut satırlarında da yapılması gerekenler yazıyor olcak. Senden istediğim sadece güncellenmiş ....html.twig dosyasını bana ver başka bişey yazma.
....html.twig :
' . $translate;
                ini_set('max_execution_time', 0);

                $data = [];
                $data['model'] = 'gpt-4o';
                $data['messages'][0]['role'] = 'user';
                $data['messages'][0]['content'] = $promp;

                $curl = curl_init();
                curl_setopt_array($curl, array(
                    CURLOPT_URL => 'https://api.openai.com/v1/chat/completions',
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_ENCODING => '',
                    CURLOPT_MAXREDIRS => 10,
                    CURLOPT_TIMEOUT => 0,
                    CURLOPT_FOLLOWLOCATION => true,
                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                    CURLOPT_CUSTOMREQUEST => 'POST',
                    CURLOPT_POSTFIELDS => json_encode($data),
                    CURLOPT_HTTPHEADER => array(
                        'Authorization: Bearer '.$bilgiler['gptKey'],
                        'Content-Type: application/json'
                    ),
                ));

                $response = curl_exec($curl);
                $response = json_decode($response, true);

                curl_close($curl);
                $choicesSay = count($response['choices']);
                $translate = $response['choices'][($choicesSay - 1)]['message']['content'];

            }
        }






        $son_grup = $this->sonGrup('Tasarim');

        if($tasarim==0){
            $tt = new Tasarim();
            $tt->setGrup($son_grup);
        }else{
            $tt = $em->getRepository(Tasarim::class)->find($tasarim);
        }
        if($modul!=0){
            $modul = $em->getReference(Modul::class,$modul);
            $tt->setModul($modul);
        }


        $tt->setTranslate(str_replace(['```twig','```'],['',''],$translate));
        $tt->setGorunum($gorunum);
        $em->persist($tt);
        $em->flush();


       return $this->redirectToRoute('tasarim_isle');
    }

    /**
     * @Route("/admin/tasarim/kaydet", name="tasarim_kaydet")
     */
    public function kaydet(Request $request): Response{
        $em = $this->getDoctrine()->getManager();


        $translate = $request->request->get('translate');
        $tasarim = $request->request->get('tasarim');


        $tt = $em->getRepository(Tasarim::class)->find($tasarim);


        $tt->setTranslate($translate);




        $em->persist($tt);
        $em->flush();


       return new Response($tt->getId());
    }

    /**
     * @Route("/admin/tasarim/tasarimIndir", name="tasarim_tasarimIndir")
     */
    public function tasarimIndir(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        @unlink('tasarimlar.zip');

        $zip = new ZipArchive();
        $zip->open('tasarimlar.zip', ZipArchive::CREATE);
        $zip->addFile('sabitSablon/_breadcrumbs.html.twig','_breadcrumbs.html.twig');
        $zip->addFile('sabitSablon/_css.html.twig','_css.html.twig');
        $zip->addFile('sabitSablon/_footer.html.twig','_footer.html.twig');
        $zip->addFile('sabitSablon/_header.html.twig','_header.html.twig');
        $zip->addFile('sabitSablon/_js.html.twig','_js.html.twig');
        $zip->addFile('sabitSablon/_slider.html.twig','_slider.html.twig');

        $qb = $em->createQueryBuilder();
        $moduller=$qb->select('m.id,m.tabloAdi,m.alan,t.id as tId')
            ->from('App:Modul', 'm')
            ->leftjoin('m.tasarim','t')
            ->getQuery()
            ->getScalarResult();

        foreach ($moduller as $modul){
            $zip->addFile('sablon/'.$this->seo($modul['tabloAdi']).'_anasayfa.html.twig',$this->seo($modul['tabloAdi']).'_anasayfa.html.twig');
            $zip->addFile('sablon/'.$this->seo($modul['tabloAdi']).'_sayfa.html.twig',$this->seo($modul['tabloAdi']).'_sayfa.html.twig');
            $zip->addFile('sablon/'.$this->seo($modul['tabloAdi']).'_kategori.html.twig',$this->seo($modul['tabloAdi']).'_kategori.html.twig');
            $zip->addFile('sablon/'.$this->seo($modul['tabloAdi']).'_icerik.html.twig',$this->seo($modul['tabloAdi']).'_icerik.html.twig');
        }
        $zip->close();


        return $this->redirect($this->ayarlar('siteYolu').'tasarimlar.zip');
    }

    /**
     * @Route("/admin/tasarim/tasarimYukle", name="tasarim_tasarimYukle")
     */
    public function tasarimYukle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $okunanVeriler = [];
        if (!empty($_FILES['dosya']['name'])) {
            for ($i = 0; $i < count($_FILES['dosya']['name']); $i++) {
                $dosyaAdi = $_FILES['dosya']['name'][$i];
                $dosya= fopen($_FILES['dosya']['tmp_name'][$i], "r");
                $dosyaVerisi = fread($dosya,filesize($_FILES['dosya']['tmp_name'][$i]));
                fclose($dosya);

                $dosyaBol = explode('_',$dosyaAdi);
                if ($dosyaBol[0]==""){
                    if ($dosyaAdi == '_css.html.twig'){
                        $veriBol = explode('<link ',$dosyaVerisi);
                        $yeniVeriler = "";
                        foreach ($veriBol as $key=>$vv){

                            if ($key!=0){
                                if (strstr($vv,'http')){
                                    $xx = $vv;
                                }else{
                                    $xx = str_replace('href="','href="/dist/',$vv);
                                }

                                $yeniVeriler .= "<link ".$xx."<noscript><link ".$xx."</noscript>";
                            }
                        }
                        $dosyaVerisi = $yeniVeriler;
                    }
                    if ($dosyaAdi == '_js.html.twig'){
                        $veriBol = explode('<script ',$dosyaVerisi);
                        $yeniVeriler = "";
                        foreach ($veriBol as $key=>$vv){
                            $xx = $vv;
                            if ($key!=0){
                                if (!strstr($vv,'http')){
                                    $xx = str_replace('src="','src="/dist/',$xx);
                                }


                                if (!strstr($xx,'defer')){
                                    if (!strstr($xx,'anakutuphane')){
                                        $xx = "defer ".$xx;
                                    }
                                }
                                $yeniVeriler .="<script ".$xx;

                            }
                        }
                        $dosyaVerisi = $yeniVeriler;
                    }



                    $okunanVeriler[explode('.',$dosyaBol[1])[0]] = $dosyaVerisi;
                }else{
                    $okunanVeriler[$dosyaBol[0]][explode('.',$dosyaBol[1])[0]] = $dosyaVerisi;
                }
            }
        }


        $qb = $em->createQueryBuilder();
        $tasarimlar=$qb->select('t.adi,t.id,t.translate,t.grup,m.adi as mAdi,t.gorunum,m.tabloAdi')
            ->from('App:Tasarim', 't')
            ->leftjoin('t.modul','m')
            ->orderBy('t.grup')
            ->getQuery()
            ->getScalarResult();

        foreach ($tasarimlar as $tasarim){
            $translate = "";
            if ($tasarim['adi']!=''){
                if (array_key_exists(strtolower($tasarim['adi']), $okunanVeriler)) {
                    $translate = $okunanVeriler[strtolower($tasarim['adi'])];
                }
            }else{
                if ($tasarim['gorunum']==0){
                    if (array_key_exists($this->seo($tasarim['tabloAdi']), $okunanVeriler)) {
                        if (array_key_exists('anasayfa', $okunanVeriler[$this->seo($tasarim['tabloAdi'])])) {
                            $translate = $okunanVeriler[$this->seo($tasarim['tabloAdi'])]['anasayfa'];
                        }
                    }
                }
                if ($tasarim['gorunum']==1){
                    if (array_key_exists($this->seo($tasarim['tabloAdi']), $okunanVeriler)) {
                        if (array_key_exists('sayfa', $okunanVeriler[$this->seo($tasarim['tabloAdi'])])) {
                            $translate = $okunanVeriler[$this->seo($tasarim['tabloAdi'])]['sayfa'];
                        }
                    }
                }
                if ($tasarim['gorunum']==2){
                    if (array_key_exists($this->seo($tasarim['tabloAdi']), $okunanVeriler)) {
                        if (array_key_exists('kategori', $okunanVeriler[$this->seo($tasarim['tabloAdi'])])) {
                            $translate = $okunanVeriler[$this->seo($tasarim['tabloAdi'])]['kategori'];
                        }
                    }
                }
                if ($tasarim['gorunum']==3){
                    if (array_key_exists($this->seo($tasarim['tabloAdi']), $okunanVeriler)) {
                        if (array_key_exists('icerik', $okunanVeriler[$this->seo($tasarim['tabloAdi'])])) {
                            $translate = $okunanVeriler[$this->seo($tasarim['tabloAdi'])]['icerik'];
                        }
                    }
                }



            }

            if ($translate!=""){
                $qb = $em->createQueryBuilder();
                $q = $qb->update('App:Tasarim', 't')
                    ->set('t.translate', ':translate')
                    ->where('t.id='.$tasarim['id'])
                    ->setParameter('translate', $translate)
                    ->getQuery()
                    ->execute();
            }



        }



        return $this->redirectToRoute('tasarim_isle');
    }


    /**
     * @Route("/admin/tasarim/modulTasarimOlustur", name="tasarim_modulTasarimOlustur")
     */
    public function modulTasarimOlustur(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $moduller=$qb->select('m.id,m.tabloAdi,m.alan,t.id as tId')
            ->from('App:Modul', 'm')
            ->leftjoin('m.tasarim','t')
            ->getQuery()
            ->getScalarResult();

        foreach ($moduller as $modul){
            if ($modul['tId']==''){
                $alanlar = str_replace([' ',','],['',', '],$modul['alan']);
                $modulll = $em->getReference(Modul::class,$modul['id']);

                // Anasayfa
                $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/public/sablon/'.$this->seo($modul['tabloAdi']).'_anasayfa.html.twig', 'w');
                $data = '{#
-- Site Sayfa Verileri : "veriler[#sayfadilgrup#]" adında bir dizi döndürülüyor. 0. elemanı sayfa bilgilerini içerir. 1 elemanı dizidir. Ve sayfa içeriğini döndürür. Bu bilgilere göre kodlama yapınız.  
-- Modül alanları : '.$alanlar.'
** Resimleri çekerken sadece "ornek.jpg|imgOlustur(100,10,\'cover\')" filtresini kullanmalısın. Bu filtre şu özelliğe sahitir; "ornek.jpg|imgOlustur(yükseklik,radius,\'cover/contain\')"

----------------------------------------------------
#}


';
                fwrite($dosya, $data);
                fclose($dosya);

                $son_grup = $this->sonGrup('Tasarim');

                $tt = new Tasarim();
                $tt->setGrup($son_grup);
                $tt->setModul($modulll);
                $tt->setTranslate($data);
                $tt->setGorunum(0);
                $em->persist($tt);
                $em->flush();

                // Sayfa
                $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/public/sablon/'.$this->seo($modul['tabloAdi']).'_sayfa.html.twig', 'w');
                $data = '{#
-- Sayfa Verileri : "icerikler" adında bir dizi döndürülüyor. Dizi elemanları : '.$alanlar.', link
-- Kategori Verileri : "kategoriler" adında bir dizi döndürülüyor. Dizi elemanları : adi, resim, link
** Eğer kategoriler dizisi boş değilse icerikler boş gelecektir. Eğer boş ise içerikler dönecektir.
** Resimleri çekerken sadece "ornek.jpg|imgOlustur(100,10,\'cover\')" filtresini kullanmalısın. Bu filtre şu özelliğe sahitir; "ornek.jpg|imgOlustur(yükseklik,radius,\'cover/contain\')"

----------------------------------------------------
#}


';
                fwrite($dosya, $data);
                fclose($dosya);

                $son_grup = $this->sonGrup('Tasarim');

                $tt = new Tasarim();
                $tt->setGrup($son_grup);
                $tt->setModul($modulll);
                $tt->setTranslate($data);
                $tt->setGorunum(1);
                $em->persist($tt);
                $em->flush();

                // Kategori
                $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/public/sablon/'.$this->seo($modul['tabloAdi']).'_kategori.html.twig', 'w');
                $data = '{#
-- Sayfa Verileri : "icerikler" adında bir dizi döndürülüyor. Dizi elemanları : '.$alanlar.', link
-- Kategori Verileri : "kategoriler" adında bir dizi döndürülüyor. Dizi elemanları : adi, resim, link
** Eğer kategoriler dizisi boş değilse icerikler boş gelecektir. Eğer boş ise içerikler dönecektir.
** Resimleri çekerken sadece "ornek.jpg|imgOlustur(100,10,\'cover\')" filtresini kullanmalısın. Bu filtre şu özelliğe sahitir; "ornek.jpg|imgOlustur(yükseklik,radius,\'cover/contain\')"

----------------------------------------------------
#}


';
                fwrite($dosya, $data);
                fclose($dosya);

                $son_grup = $this->sonGrup('Tasarim');

                $tt = new Tasarim();
                $tt->setGrup($son_grup);
                $tt->setModul($modulll);
                $tt->setTranslate($data);
                $tt->setGorunum(2);
                $em->persist($tt);
                $em->flush();

                // İçerik
                $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/public/sablon/'.$this->seo($modul['tabloAdi']).'_icerik.html.twig', 'w');
                $data = '{#
-- Sayfa Verileri : "icerik" adında bir dizi döndürülüyor. Dizi elemanları : '.$alanlar.', link
-- Büyük resim için : #resimAlani# yazmanız yeterli olcaktır.
-- Sol veya Sağ menüler için : "solMenuler" adında bir dizi döndürülüyor. Dizi elemanları : adi, link, resim
-- İletişim bilgileri için : {{ \'alan\'|site_iletisimBilgileri|raw }} kullanın. Ör: {{ \'telefon\'|site_iletisimBilgileri|raw }}
** Resimleri çekerken sadece "ornek.jpg|imgOlustur(100,10,\'cover\')" filtresini kullanmalısın. Bu filtre şu özelliğe sahitir; "ornek.jpg|imgOlustur(yükseklik,radius,\'cover/contain\')"

----------------------------------------------------
#}


';
                fwrite($dosya, $data);
                fclose($dosya);

                $son_grup = $this->sonGrup('Tasarim');

                $tt = new Tasarim();
                $tt->setGrup($son_grup);
                $tt->setModul($modulll);
                $tt->setTranslate($data);
                $tt->setGorunum(3);
                $em->persist($tt);
                $em->flush();



            }
        }


       return new Response('');
    }

    /**
     * @Route("/admin/tasarim/isle", name="tasarim_isle")
     */
    public function isle(Request $request): Response{
        $em = $this->getDoctrine()->getManager();

        $qb = $em->createQueryBuilder();
        $tasarimlar=$qb->select('t.adi,t.translate,m.id as mId,m.alan,m.adi as mAdi,t.grup,t.gorunum')
            ->from('App:Tasarim', 't')
            ->leftjoin('t.modul','m')
            ->orderBy('t.grup')
            ->groupBy('t.grup')
            ->getQuery()
            ->getScalarResult();

        foreach ($tasarimlar as $key=>$tasarim){
            if ($tasarim['mId']==""){
                if($tasarim['adi']=='Css'){
                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/siteBase/style.html.twig', 'w');
                    $data="";
                    $data .= $tasarim['translate'];
                    $data .= "
                    
                    {% include 'siteBase/sabitCSS.html.twig' %}";

                    fwrite($dosya, $data);
                    fclose($dosya);
                }
                elseif($tasarim['adi']=='Header'){
                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/siteBase/header.html.twig', 'w');
                    $data="";
                    $data .= '<body onload=" if($(\'.preloader\').length){$(\'.preloader\').delay(200).fadeOut(500); }">
<div class="preloader">
</div>

';
                    $data .= $tasarim['translate'];


                    fwrite($dosya, $data);
                    fclose($dosya);
                }
                elseif($tasarim['adi']=='Footer'){
                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/siteBase/footer.html.twig', 'w');
                    $data="";


                    $data .= $tasarim['translate'];


                    fwrite($dosya, $data);
                    fclose($dosya);
                }
                elseif($tasarim['adi']=='Js'){
                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/siteBase/js.html.twig', 'w');
                    $data="";
                    $data .= $tasarim['translate'];
                    $data .= "
                    
                    {% include 'siteBase/sabitJS.html.twig' %}";

                    fwrite($dosya, $data);
                    fclose($dosya);
                }
                elseif($tasarim['adi']=='Breadcrumbs'){
                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/siteBase/breadcrumbs.html.twig', 'w');
                    $data="";
                    $data .= $tasarim['translate'];

                    fwrite($dosya, $data);
                    fclose($dosya);
                }
            }
            else{
                $entity = $this->seo(str_replace(' ','',$tasarim['mAdi']));

                if ($tasarim['gorunum']==1){

                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'.html.twig', 'w');
                    $data="";
                    $data.="{% extends 'siteBase.html.twig' %}
{% block dil %}{{ app.session.get('dil')['kisa'] }}{% endblock %} {# tr or en #}
{% block title %}{{ sayfa.title }}{% endblock %}
{% block keywords %}{{ sayfa.keywords }}{% endblock %}
{% block description %}{{ sayfa.description }}{% endblock %}

{% block title2 %}{{ sayfa.title }}{% endblock %}
{% block description2 %}{{ sayfa.description }}{% endblock %}
{% block image_alt %}{{ sayfa.title }}{% endblock %}
{% block title3 %}{{ sayfa.title }}{% endblock %}
{% block description3 %}{{ sayfa.description }}{% endblock %}
{% block image %}{{ sayfa.dilgrup|site_bannerGetir|raw }}{% endblock %}
{% block image2 %}{{ sayfa.dilgrup|site_bannerGetir|raw }}{% endblock %}
 
 
{% block body %}
{% include 'siteBase/breadcrumbs.html.twig' %}
 
  ";
                    $data .= $tasarim['translate'];

                    $data .= "
                    
                    {% endblock %}
{% block javascripts %}{% endblock %}";

                    fwrite($dosya, $data);
                    fclose($dosya);
                }
                if ($tasarim['gorunum']==2){

                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'_kategori.html.twig', 'w');
                    $data="";
                    $data.="{% extends 'siteBase.html.twig' %}
{% block dil %}{{ app.session.get('dil')['kisa'] }}{% endblock %} {# tr or en #}
{% block title %}{{ kategori.title }}{% endblock %}
{% block keywords %}{{ kategori.keywords|default('') }}{% endblock %}
{% block description %}{{ kategori.description|default('') }}{% endblock %}

{% block title2 %}{{ kategori.title }}{% endblock %}
{% block description2 %}{{ kategori.description|default('') }}{% endblock %}
{% block image_alt %}{{ kategori.title }}{% endblock %}
{% block title3 %}{{ kategori.title }}{% endblock %}
{% block description3 %}{{ kategori.description|default('') }}{% endblock %}
{% block image %}{{ 'siteYolu'|ayarlar~'storage/' }}{{ kategori.resim|default('logo.webp') }}{% endblock %}
{% block image2 %}{{ 'siteYolu'|ayarlar~'storage/' }}{{ kategori.resim|default('logo.webp') }}{% endblock %}
{% block body %}
    {% set oncekiKategoriler = kategori.ustid|site_kategoriGeriLi(app.session.get('dil')['id'])|split('~') %}

    {% include 'siteBase/breadcrumbs.html.twig' %}
 
  ";
                    $data .= $tasarim['translate'];

                    $data .= "
                    
                    {% endblock %}
{% block javascripts %}{% endblock %}";

                    fwrite($dosya, $data);
                    fclose($dosya);
                }
                if ($tasarim['gorunum']==3){

                    $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/modul/'.$entity.'_ic.html.twig', 'w');
                    $data="";
                    $data.="{% extends 'siteBase.html.twig' %}
{% block dil %}{{ app.session.get('dil')['kisa'] }}{% endblock %} {# tr or en #}
{% block title %}{{ icerik.sayfabasligi|html_entity_decode|raw }}{% endblock %}
{% block keywords %}{{ icerik.anahtarkelimeler|html_entity_decode|raw }}{% endblock %}
{% block description %}{{ icerik.sayfaaciklamasi|html_entity_decode|raw }}{% endblock %}
{% block title2 %}{{ icerik.sayfabasligi|html_entity_decode|raw }}{% endblock %}
{% block description2 %}{{ icerik.sayfaaciklamasi|html_entity_decode|raw }}{% endblock %}
{% block image_alt %}{{ icerik.sayfabasligi|html_entity_decode|raw }}{% endblock %}
{% block title3 %}{{ icerik.sayfabasligi|html_entity_decode|raw }}{% endblock %}
{% block description3 %}{{ icerik.sayfaaciklamasi|html_entity_decode|raw }}{% endblock %}
{% block image %}{{ 'siteYolu'|ayarlar~'storage/' }}{{ resimler[0]|default(icerik.resim|default('logo.webp')) }}{% endblock %}
{% block image2 %}{{ 'siteYolu'|ayarlar~'storage/' }}{{ resimler[0]|default(icerik.resim|default('logo.webp')) }}{% endblock %}
    {% block body %}
    {% include 'siteBase/breadcrumbs.html.twig' %}
  ";
                    $resimler = '<div class="row">{% for resim in icerik.resimler|split(",") %}{% if resim|default("")!="" %}<div class="col-md-6 mb-3"><a href="/storage/{{ resim }}" data-fancybox="gallery">{{ resim|imgOlustur(300,10)|raw }}</a></div>{% endif %} {% endfor %}</div>';
                    $resim = '{{ icerik.resim|imgOlustur(450,10)|raw }}';

                    $x = "";
                    $alanlar = explode(',',$tasarim['alan']);
                    if (in_array('resimler',$alanlar)){
                        $x = $resimler;
                    }else{
                        $x = $resim;
                    }

                    $data .= str_replace('#resimAlani#',$x,$tasarim['translate']);

                    $data .= "
                    
                    {% endblock %}
{% block javascripts %}{% endblock %}";

                    fwrite($dosya, $data);
                    fclose($dosya);
                }

            }

        }

        $qb = $em->createQueryBuilder();
        $slider=$qb->select('t.translate')
            ->from('App:Tasarim', 't')
            ->where('t.grup=5')
            ->orderBy('t.grup')
            ->groupBy('t.grup')
            ->getQuery()
            ->getScalarResult();

        $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/templates/modul/index.html.twig', 'w');
        $data="";
        $data.="{% extends 'siteBase.html.twig' %}
{# Sayfa İstekleri #}
{% set sBoyutlar = 'slider'|ayarlar|split('X') %}
{% set sliders = ''|site_sliders %}


{% block dil %}{{ app.session.get('dil')['kisa'] }}{% endblock %} {# tr or en #}
{% block title %}{{ 'title'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block keywords %}{{ 'keywords'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block description %}{{ 'description'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}

{% block title2 %}{{ 'title'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block description2 %}{{ 'description'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block image_alt %}{{ 'title'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block title3 %}{{ 'title'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block description3 %}{{ 'description'|ayarlar(app.session.get('dil')['id']) }}{% endblock %}
{% block image %}{{ 'siteYolu'|ayarlar~'storage/logo.webp' }}{% endblock %}
{% block image2 %}{{ 'siteYolu'|ayarlar~'storage/logo.webp' }}{% endblock %}
{% block body %}
 
  ";
        $data .= $this->digerTasarimlar(5);



        $qb = $em->createQueryBuilder();
        $sayfalar=$qb->select('m.id as mId,s.dilgrup')
            ->from('App:Sayfa', 's')
            ->join('s.dil', 'd')
            ->join('s.modul', 'm')
            ->where('s.anasayfa=1')
            ->orderBy('s.sira','ASC')
            ->groupBy('s.dilgrup')
            ->getQuery()
            ->getScalarResult();

        foreach ($sayfalar as $sayfa){
            $qb = $em->createQueryBuilder();
            $anasayfalar=$qb->select('t.translate,t.grup')
                ->from('App:Tasarim', 't')
                ->join('t.modul','m')
                ->where('t.gorunum=0 and t.translate is not null and m.id='.$sayfa['mId'])
                ->orderBy('t.sira')
                ->groupBy('t.grup')
                ->getQuery()
                ->getScalarResult();

            if (count($anasayfalar)>0){
                $html = $this->digerTasarimlar($anasayfalar[0]['grup']);
                $data .= str_replace('#sayfadilgrup#',$sayfa['dilgrup'],$html);
            }
        }



        $data .= "
                    
                    {% endblock %}
{% block javascripts %}{% endblock %}";

        fwrite($dosya, $data);
        fclose($dosya);



       return new Response('');
    }

    /**
     * @Route("/admin/tasarim/temayukle", name="tasarim_temayukle")
     */
    public function temayukle(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        if(!file_exists("dist")) {
            mkdir("dist");
        }else{
            $this->emptyDir("dist");
            rmdir("dist");
            mkdir("dist");
        }

        $dosya='dosya_'.time();
        move_uploaded_file($_FILES['dosya']['tmp_name'], "dist/".$dosya.$this->uzantiBul($_FILES['dosya']['type']));
        $dosya = $dosya.$this->uzantiBul($_FILES['dosya']['type']);

        $zip = new ZipArchive();
        $zip->open('dist/'.$dosya);
        $zip->extractTo('dist/');
        $zip->close();

        unlink('dist/'.$dosya);

        return new Response('');
    }

    /**
     * @Route("/admin/tasarim/sistemKlonla", name="tasarim_sistemKlonla")
     */
    public function sistemKlonla(Request $request): Response
    {
        $em = $this->getDoctrine()->getManager();

        $bilgiler = $this->bilgiler();

        $isim = $this->seo($request->request->get('isim'));
        if ($isim!="") {




            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://rvyazilim.net:2083/cpsess5487058506/execute/SubDomain/addsubdomain?domain=' . $isim . '.rvyazilim.net&rootdomain=rvyazilim.net&dir=/public_html/' . $isim,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'GET',
                CURLOPT_HTTPHEADER => array(
                    "Authorization: Basic " . base64_encode($bilgiler['username'] . ":" . $bilgiler['password'])
                ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);

            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://rvyazilim.net:2083/cpsess5487058506/execute/Mysql/create_database?name='.$bilgiler['username'].'_' . $isim,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'GET',
                CURLOPT_HTTPHEADER => array(
                    "Authorization: Basic " . base64_encode($bilgiler['username'] . ":" . $bilgiler['password'])
                ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);


            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://rvyazilim.net:2083/cpsess5487058506/execute/Mysql/set_privileges_on_database?user='.$bilgiler['username'].'_user_sites&database='.$bilgiler['username'].'_' . $isim . '&privileges=ALL%20PRIVILEGES',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'GET',
                CURLOPT_HTTPHEADER => array(
                    "Authorization: Basic " . base64_encode($bilgiler['username'] . ":" . $bilgiler['password'])
                ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);

            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => 'https://rvyazilim.net:2083/cpsess5487058506/execute/SSL/start_autossl_check',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'GET',
                CURLOPT_HTTPHEADER => array(
                    "Authorization: Basic " . base64_encode($bilgiler['username'] . ":" . $bilgiler['password'])
                ),
            ));
            $response = curl_exec($curl);
            curl_close($curl);


            $dosya= fopen('stok.sql', "r");
            $dosyaVerisi = fread($dosya,filesize('stok.sql'));
            fclose($dosya);

            $dosyaVerisi = str_replace("'exportsites'","'$isim'",$dosyaVerisi);
            $dosyaVerisi = str_replace("'https://www.exportsites.rvyazilim.net/'","'https://www.$isim.rvyazilim.net/'",$dosyaVerisi);
            $dosya= fopen('stok_gecici.sql', "w");
            fwrite($dosya, $dosyaVerisi);
            fclose($dosya);

            shell_exec("mysql -u ".$bilgiler['username']."_user_sites --password=rvrv10091995* ".$bilgiler['username']."_$isim < " . $_SERVER['DOCUMENT_ROOT'] . "/public/stok_gecici.sql");
            shell_exec("rm -r /home/".$bilgiler['username']."/public_html/" . $isim);
            shell_exec("cp -r /home/".$bilgiler['username']."/public_html/exportsites/ /home/".$bilgiler['username']."/public_html/" . $isim);
            shell_exec("chmod 777 -R /home/".$bilgiler['username']."/public_html/" . $isim);
            shell_exec("chmod 777 -R /home/".$bilgiler['username']."/public_html/" . $isim.'/');
            shell_exec("rm -r /home/".$bilgiler['username']."/public_html/" . $isim.'/var/cache');
            shell_exec("rm -r /home/".$bilgiler['username']."/public_html/" . $isim.'/var/log');

            @unlink('stok_gecici.sql');


            $data = '# In all environments, the following files are loaded if they exist,
# the latter taking precedence over the former:
#
#  * .env                contains default values for the environment variables needed by the app
#  * .env.local          uncommitted file with local overrides
#  * .env.$APP_ENV       committed environment-specific defaults
#  * .env.$APP_ENV.local uncommitted environment-specific overrides
#
# Real environment variables win over .env files.
#
# DO NOT DEFINE PRODUCTION SECRETS IN THIS FILE NOR IN ANY OTHER COMMITTED FILES.
#
# Run "composer dump-env prod" to compile .env files for production use (requires symfony/flex >=1.2).
# https://symfony.com/doc/current/best_practices.html#use-environment-variables-for-infrastructure-configuration

###> symfony/framework-bundle ###
APP_ENV=dev
APP_SECRET=bc37180bbf2e3702931fb059683338de
###< symfony/framework-bundle ###

###> symfony/mailer ###<epBol
MAILER_DSN=smtp://support@rvyazilim.com:rvrv**2020@smtp.yandex.com.tr:465
#epBol>
###< symfony/mailer ###

###> doctrine/doctrine-bundle ###
# Format described at https://www.doctrine-project.org/projects/doctrine-dbal/en/latest/reference/configuration.html#connecting-using-a-url
# IMPORTANT: You MUST configure your server version, either here or in config/packages/doctrine.yaml
#
# DATABASE_URL="sqlite:///%kernel.project_dir%/var/data.db"
# DATABASE_URL="mysql://db_user:db_password@127.0.0.1:3306/db_name?serverVersion=5.7&charset=utf8mb4"
#DATABASE_URL="postgresql://symfony:ChangeMe@127.0.0.1:5432/app?serverVersion=13&charset=utf8"<dbBol
DATABASE_URL="mysql://'.$bilgiler['username'].'_user_sites:rvrv10091995*@127.0.0.1:3306/'.$bilgiler['username'].'_exportsites?serverVersion=5.7"
#dbBol>###< doctrine/doctrine-bundle ###

###> google/apiclient ###
GOOGLE_API_KEY=
GOOGLE_CLIENT_ID=
GOOGLE_CLIENT_SECRET=
###< google/apiclient ###';


            $dosya = fopen($_SERVER['DOCUMENT_ROOT'].'/public/.stokEnv', "w");
            $data = str_replace(''.$bilgiler['username'].'_exportsites',''.$bilgiler['username'].'_'.$isim,$data);
            fwrite($dosya, $data);
            fclose($dosya);

            shell_exec("cp -r /home/".$bilgiler['username']."/public_html/exportsites/public/.stokEnv /home/".$bilgiler['username']."/public_html/" . $isim.'/.env');
            shell_exec("cp /home/".$bilgiler['username']."/public_html/exportsites/public/stokLogo/logo.webp /home/".$bilgiler['username']."/public_html/" . $isim.'/public/uploads/logo.webp');
            shell_exec("cp /home/".$bilgiler['username']."/public_html/exportsites/public/stokLogo/beyazLogo.webp /home/".$bilgiler['username']."/public_html/" . $isim.'/public/uploads/beyazLogo.webp');
            shell_exec("cp /home/".$bilgiler['username']."/public_html/exportsites/public/stokLogo/favicon.webp /home/".$bilgiler['username']."/public_html/" . $isim.'/public/uploads/favicon.webp');


            

            shell_exec("rm /home/".$bilgiler['username']."/public_html/" . $isim."/public/stokEnv");
            shell_exec("rm /home/".$bilgiler['username']."/public_html/" . $isim."/public/.stokEnv");

        }

        return new Response('');
    }



    /**
     * @Route("/admin/tasarim/gpt", name="tasarim_gpt")
     */
    public function gpt(Request $request): Response
    {




        return new Response('');
    }



}
